using System.Diagnostics;
using System.Data;
using System.Collections;
using Microsoft.VisualBasic;
using System.Collections.Generic;
using System;

namespace Optim_RandomSearch3
{
	public delegate double MyFxDelegate(int nNumVars, ref double[] fX, ref double[] fParam);
	public delegate string SayFxDelegate();
	
	public class CRandomSearch3
	{
		
		
		public double CalcOptim(int nNumVars, ref double[] fX, ref double[] fParam, ref double[] fRadius, int nMaxIter, double EpsFx, ref int nIter, MyFxDelegate MyFx)
		{
			
			double F, fBestF, fLastBestF;
			double[] fBestX;
			int i;
            Random objRand = new Random();
			
			fBestX = new double[nNumVars + 1];
			
			for (i = 0; i < nNumVars; i++)
			{
				fBestX[i] = fX[i];
			}
			// calculate and display function value at initial point
            fBestF = MyFx(nNumVars, ref fBestX, ref fParam);
			if (fBestF > 0)
			{
				fLastBestF = fBestF + 100;
			}
			else
			{
				fLastBestF = 100 - fBestF;
			}
			
			nIter = 0;
			do
			{
				nIter++;
				if (nIter > nMaxIter)
				{
					break;
				}
				for (i = 0; i < nNumVars; i++)
				{
					fX[i] = fBestX[i] +(objRand.NextDouble() - 0.5) * fRadius[i];
				}
                F = MyFx(nNumVars, ref fX, ref fParam);
				if (F < fBestF)
				{
					for (i = 0; i < nNumVars; i++)
					{
						fBestX[i] = fX[i];
					}
					fBestF = F;
					
					// test function value convergence
					if (Math.Abs(fBestF - fLastBestF) < EpsFx)
					{
						break;
					}
					fLastBestF = fBestF;
				}
			} while (true);
			
			return fBestF;
			
		}
	}
	
	
}
